# -*- coding: utf-8 -*-
# (c) 2oo8 by Chrisber
# Version 1.0 27/12/08
# mail@chrisber.de
# http://www.chaos-club.eu
import es, os.path
from configobj import ConfigObj



#
# Information
#
info             = es.AddonInfo()
info.name        = "nativeINI"
info.basename    = "nativeINI"
info.version     = "1.0 27/12/08"
info.author      = "Chrisber"
info.url         = "http://www.chaos-club.eu"
info.description = "A useful config that returns native values"
info.tags        = "config ini native"



#
# Functions
#
def parse(path):
	return NativeINI(path).getList()



#
# Classes
#
class NativeINI:
	def __init__(self, path):
		self.path = "%s/%s" % (es.getString("eventscripts_gamedir"), path)
		
		if os.path.isfile(self.path):
			self.cfg = ConfigObj(self.path)
			
			for key in self.cfg:
				for option in self.cfg[key]:
					if type(self.cfg[key][option]) == list:
						counter = 0
						
						for entry in self.cfg[key][option]:
							self.cfg[key][option][counter] = self.getNative(entry)
							counter += 1
					else:
						self.cfg[key][option] = self.getNative(self.cfg[key][option])
	def getNative(self, text):
		text = str(text)
		
		if text in ["True", "False"]:
			return True if text == "True" else False
		elif text.replace("-", "").isdigit():
			return int(text)
		elif text.count(".") == 1 and text.replace(".", "").isdigit():
			return float(text)
		
		return text
	def getList(self):
		if os.path.isfile(self.path):
			return self.cfg
		
		return False